	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE 65c02smac.h
	INCLUDE 65c02s.h
	INCLUDE gfx.h
	INCLUDE io.h

	IMPORT findrom ;from main.c

	EXPORT loadcart
	EXPORT map89AB_
	EXPORT mapCDEF_
	EXPORT savestate
	EXPORT loadstate
	EXPORT g_emuflags
	EXPORT romstart
	EXPORT romnum
	EXPORT g_scaling
	EXPORT g_cartflags
;----------------------------------------------------------------------------
 AREA rom_code, CODE, READONLY
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
loadcart ;called from C:  r0=rom number, r1=emuflags
;----------------------------------------------------------------------------
	stmfd sp!,{r0-r1,r4-r11,lr}

	ldr r1,=findrom
	bl thumbcall_r1
	add r0,r0,#48		;r0 now points to rom image (including header)

	ldr globalptr,=|wram_globals0$$Base|	;need ptr regs init'd
	ldr nes_zpage,=NES_RAM

	add r3,r0,#16
	str r3,rombase		;set rom base
						;r3=rombase til end of loadcart so DON'T FUCK IT UP

	ldmfd sp!,{r0-r1}
	str r0,romnumber
	str r1,emuflags

;dum
;	ldr r0,breakp
;	cmp r0,#0
;	beq dum

	mov r2,#1
	mov r1,#4			;4x16kB
	rsb r0,r2,r1,lsl#14
	str r0,rommask		;rommask=romsize-1

	mov r0,#0		;default ROM mapping
	bl map89AB_		;89AB=1st 16k
	mov r0,#-1
	bl mapCDEF_		;CDEF=last 16k

	ldrb r0,[r3,#-10]
	ldrb r1,[r3,#-9]
	and r0,r0,#0x0f
	orr r1,r0,r1,lsl#4
	strb r1,cartflags		;set cartflags

;	ldr r0,=default_scanlinehook
	ldr r0,=timer_scanlinehook
	str r0,scanlinehook	;no mapper irq

	mov r0,#0xe0		;was 0xe0
	mov r1,#AGB_OAM
	mov r2,#0x100
	bl filler_		;no stray sprites please

	mov r0,#0		;clear wsv ram
	mov r1,nes_zpage
	mov r2,#0x2000/4
	bl filler_

	;ldr r1,=MEM_AGB_SCREEN	;clear AGB BG
	;mov r2,#32*32*2
	;bl filler_

	mov nes_pc,#0		;(eliminates any encodePC errors during mapper*init)
	str nes_pc,lastbank


	bl nes_reset		;reset everything else
	ldmfd sp!,{r4-r11,lr}
	bx lr
;----------------------------------------------------------------------------
savestate	;called from ui.c.
;int savestate(void *here): copy state to <here>, return size
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r6,globalptr,lr}

	ldr globalptr,=|wram_globals0$$Base|

	ldr r2,rombase
	rsb r2,r2,#0			;adjust rom maps,etc so they aren't based on rombase
	bl fixromptrs			;(so savestates are valid after moving roms around)

	mov r6,r0			;r6=where to copy state
	mov r0,#0			;r0 holds total size (return value)

	adr r4,savelst			;r4=list of stuff to copy
	mov r3,#(lstend-savelst)/8	;r3=items in list
ss1	ldr r2,[r4],#4				;r2=what to copy
	ldr r1,[r4],#4				;r1=how much to copy
	add r0,r0,r1
ss0	ldr r5,[r2],#4
	str r5,[r6],#4
	subs r1,r1,#4
	bne ss0
	subs r3,r3,#1
	bne ss1

	ldr r2,rombase
	bl fixromptrs

	ldmfd sp!,{r4-r6,globalptr,lr}
	bx lr

savelst	DCD rominfo,8,NES_RAM,0x2000,NES_VRAM,0x2000,agb_pal,96
	DCD rommap,16,cpustate,44,ppustate,32
lstend

fixromptrs	;add r2 to some things
	adr r1,memmap_tbl+16
	ldmia r1,{r3-r6}
	add r3,r3,r2
	add r4,r4,r2
	add r5,r5,r2
	add r6,r6,r2
	stmia r1,{r3-r6}

	ldr r3,lastbank
	add r3,r3,r2
	str r3,lastbank

	ldr r3,cpuregs+6*4	;6502 PC
	add r3,r3,r2
	str r3,cpuregs+6*4

	mov pc,lr
;----------------------------------------------------------------------------
loadstate	;called from ui.c
;void loadstate(int rom#,u32 *stateptr)	 (stateptr must be word aligned)
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r7,globalptr,lr}

	mov r6,r1		;r6=where state is at
	ldr globalptr,=|wram_globals0$$Base|

        ldr r1,[r6]             ;emuflags
	bl loadcart		;cart init

	mov r0,#(lstend-savelst)/8	;read entire state
	adr r4,savelst
ls1	ldr r2,[r4],#4
	ldr r1,[r4],#4
ls0	ldr r5,[r6],#4
	str r5,[r2],#4
	subs r1,r1,#4
	bne ls0
	subs r0,r0,#1
	bne ls1

	ldr r2,rombase		;adjust ptr shit (see savestate above)
	bl fixromptrs




	ldrb r0,lcdctrl	;prep buffered DMA stuff
	bl _2026w
	bl newX

	ldmfd sp!,{r4-r7,globalptr,lr}
	bx lr
;----------------------------------------------------------------------------
 AREA wram_code4, CODE, READWRITE
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
map89AB_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0x8000
	ldr r2,rommask
	and r0,r2,r0,lsl#14
	add r0,r1,r0
	str r0,memmap_tbl+16
	str r0,memmap_tbl+20
flush		;update nes_pc & lastbank
	ldr r1,lastbank
	sub nes_pc,nes_pc,r1
	encodePC
	mov pc,lr
;----------------------------------------------------------------------------
mapCDEF_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0xc000
	ldr r2,rommask
	and r0,r2,r0,lsl#14
	add r0,r1,r0
	str r0,memmap_tbl+24
	str r0,memmap_tbl+28
	b flush
;----------------------------------------------------------------------------
 [ BUILD = "DEBUG"
 AREA ZZZZZ, DATA, READWRITE ;MUST be last area

	DCB "Alien.sv 9abcdef0123456789abcde",0
	DCD 65536+16 ;romsize
	DCD 0 ;flags
	DCD 0 ;follow
	DCD 0 ;saveslot
	DCB "NES",0x1a,0,0,0,0,0,0,0,0,0,0,0,0
	INCBIN roms\Alien.sv

 ]
;----------------------------------------------------------------------------
 AREA wram_globals2, CODE, READWRITE

romstart
	DCD 0 ;rombase
romnum
	DCD 0 ;romnumber
rominfo                 ;keep emuflags/BGmirror together for savestate/loadstate
g_emuflags	DCB 0 ;emuflags        (label this so UI.C can take a peek) see equates.h for bitfields
g_scaling	DCB 0
	% 2   ;(sprite follow val)
	DCD 0 ;BGmirror		(BG size for BG0CNT)

	DCD 0 ;rommask
g_cartflags
	DCB 0 ;cartflags
;----------------------------------------------------------------------------
	END
